<?php
include "fefunctions.php";
include "iocommand.php";
start_session();

   /***********************************************************************
   *    Copyright  2002 - 2006 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

$_SESSION["page"] = "catalogstatus.php";
$_SESSION["chrashedHere"] = "";
$aTcHasCrashed = false;
?>
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <title>HP Insight Diagnostics</title>
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
  <style> body { background: white; } </style>
</head>
<body onLoad="setTimeout('nextPage()', 1000)">
<?php
  $pid = $_REQUEST["pid"];

  $statusCommand = sprintf("<getProcessStatus processID='%s' />", $pid);

  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $statusCommand, $idStatus, $idErrors);
  $xmldoc = new DomDocument($idStatus);
  $rootElement = $xmldoc->document_element();
  
  $percentComplete = $rootElement->get_attribute("percentComplete");

  if (strlen($percentComplete) == 0) // if empty
    $percentComplete = 0; // set to zero
  
  $state = $rootElement->get_attribute("state");
  
?>
  <table align=center>
    <tr>
      <td class=head align=center>
<?php
      printf("%s", TR("MSG_BUILDING_CATALOG"));
?>
       </td>
    </tr>
    <tr>
      <td align=center>
<?php
      printf("%s %s %s, %s...", TR("MSG_RETRIEVING"), TR("MSG_TEST_COMPONENT"), TR("MSG_CATALOG"), TR("MSG_PLEASE_WAIT"));
?>
</td>
    </tr>
    <tr>
    <?php
      if ($state == "running")
        printf("<td align=center><img src='hourglassani.gif'></td>\n");
    ?>
    </tr>
  </table>
  <table align=center>
    <tr>
      <td colspan=2>
        <?php  printf("<center>%s:</center><br>\n", TR("MSG_TEST_COMPONENT")); ?>
	  </td>
    </tr>    
<?php
  $Xpath = @xpath_new_context($rootElement);
	$processStatuss = @xpath_eval($Xpath, "/processStatus");
	$num_processStatuss = count($processStatuss->nodeset); 
	for ($i=0; $i < $num_processStatuss; $i++)
	{     
	  $processStatus = $processStatuss->nodeset[$i];
    $component = $processStatus->get_attribute("component");
    $percentComplete = $processStatus->get_attribute("percentComplete");
    $tcstate = $processStatus->get_attribute("state");
    printf("<tr><td>%s<b>%s</b></td>\n<td>", $statusgif, $component);
    if ($tcstate == "completed")
    {
      printf("<img src='ok.gif'> %s", TR("MSG_COMPLETED"));
    }
    else if ($tcstate == "crashed")
    {
      $aTcHasCrashed = true;
      printf("<img src='failed.gif'> %s", TR("MSG_ABNORMAL_TERMINATION"));
    }
    else
    {
      printf("%s...", TR("MSG_LOADING"));
    }
    printf("</td>\n</tr>\n");
  }  
  printf("</table>\n");

  if ($state != "running" && $state != "submitted")
  {
    if ($aTcHasCrashed)
      printf("<center>%s %s<br>%s</center>", TR("MSG_ONE_OR_MORE_TCS_FAILED"), TR("MSG_CATALOG"), MakeButton(TR("Continue"), "window.location = 'tccatalog.php';"));
    
    $resultCommand = sprintf("<getProcessResult processID='%s' />", $pid);
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $resultCommand, $_SESSION["catalogResult"], $idErrors);
    if ($state == "crashed")
    {
      printf("<center><b>%s</b></center><br>\n", TR("MSG_ABNORMAL_TERMINATION"));
      $idXml = new DomDocument($_SESSION["catalogResult"]);
      $idXpath = xpath_new_context($idXml->document_element());
      $errors = xpath_eval($idXpath, "/error");
      foreach ($errors->nodeset as $errorNode)
        printf("<center><b>%s</b></center><br>\n", $errorNode->get_content());      
    }
  }
?>
<script language='JavaScript'>
function nextPage()
{
<?php
  if ($state == "running" || $state == "submitted")
    printf("window.location = 'catalogstatus.php?pid=%s';", $pid);
  else if ($state != "crashed" && !$aTcHasCrashed) // if passed
  	printf("window.location = 'tccatalog.php';");  
    
?>
}</script>
<script language="Javascript" src="norightclick.js"></script></body>
</html>
